<template>

  <div class="contenido">
     <vue-headful title="Hack a Market | Clientes" />
      <clienttable v-on:datos="mostrarInfoCliente" :clientes="clientes" v-on:borrar="borrandoCliente" />

      <!--Modal para actualizar cliente-->
      <div v-show="seeModal" class="modal">
        <div class="modalBox">
          <h3>
            Actualiza los datos de tu cliente:
          </h3>
          <p>
            ID del Cliente: {{ idCliente }}
          </p>
          <input type="text" placeholder="Nombre del cliente" v-model="nombreActualizado"><br>
          <input type="text" placeholder="Usuario" v-model="usuarioActualizado"><br>
          <input type="text" placeholder="Password" v-model="passwordActualizada"><br>
          <input type="text" placeholder="e-mail" v-model="emailActualizada"><br>
          <input type="text" placeholder="Foto" v-model="fotoActualizada"><br>
          <button @click="seeModal =! seeModal">
            Cancelar
          </button>
          <button @click="actualizarCliente()">
            Actualizar cliente
          </button>
      </div>
      </div>
  </div>
</template>

<script>
import axios from 'axios';
import vueHeadful from 'vue-headful';
import clienttable from '@/components/ClientTable.vue';
import Swal from "sweetalert2";
export default {
  name: 'Home',
  components: {
    clienttable
  },
  data(){
    return{
      clientes: [],
      idCliente: '',
      nombreActualizado: '',
      usuarioActualizado: '',
      passwordActualizada: '',
      emailActualizada: '',
      fotoActualizada: '',
      seeModal: false
    }
  },
  methods: {
    borrandoCliente(indiceCliente){
      var self = this;
      axios.delete('http://localhost:3308/delete/' + indiceCliente, {
      })
      .then( function(response) {
        console.log(response)
      })
      .catch( function (error) {
        console.log(error)
      } )
      location.reload()
    },
    actualizarCliente(){
      var self = this;
      axios.put('http://localhost:3308/update/' + self.idCliente, {
        nombre: self.nombreActualizado,
        usuario: self.usuarioActualizado,
        password: self.passwordActualizada,
        email: self.emailActualizada,
        foto: self.fotoActualizada
      })
      .then( function(response) {
        console.log(response)
      })
      .catch( function (error) {
        console.log(error)
      } )
      location.reload()
    },
    mostrarInfoCliente(datosCliente){
      this.nombreActualizado = datosCliente.nombre
      this.usuarioActualizado = datosCliente.usuario
      this.passwordActualizada = datosCliente.password
      this.emailActualizada = datosCliente.email
      this.fotoActualizada = datosCliente.foto
      this.idCliente = datosCliente.id

      this.seeModal = true
    },
    // FUNCIÓN PARA CONSEGUIR MIS CLIENTES
    getClients(){
      var self = this;

      // LLAMADA DE AXIOS A LA API
      axios.get('http://localhost:3308/clientes')
      .then( function(response) {
        self.clientes = response.data
      })
      .catch( function (error) {
        console.log(error)
      } )
    }
  },
  created() {
    this.getClients()
  }

}

</script>


<style scoped>
@import url('https://fonts.googleapis.com/css2?family=Source+Sans+Pro:wght@200&display=swap');

.contenido {
  font-family: 'Source Sans Pro', sans-serif;
  padding-top: 150px;
  display:block;
margin:auto;
text-align: center;
}
.modal {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  width: 100%;
  background: rgba(0, 0, 0, 0.5);
}
.modalBox {
  background-color: #fefefe;
  margin: 2%auto;
  padding: 3rem;
  width: 80%;
  border: 1px solid #888;
}
div{
  text-align: left; 
}

ul {
  text-align: left; 
  list-style: none;
  padding-inline-start: 0px;
}

li{
  line-height: auto;
}
.title {
  grid-area: d;
  text-align: center;
}
.item1 {
  grid-area: a;
  text-align: left;
  padding: 15px;
  background-color: whitesmoke;

}
.item2 {
  grid-area: b;
}
.centrado{
  text-align: center;
  width: 400px;
}

input{
  padding:8px;
  display:block;
  border:none;
  border-bottom:1px solid #ccc;
  width:400px
  }

button {
    background-color: green;
    border: none;
    color: white;
    padding: 15px 32px;
    text-align: center;
    text-decoration: none;
    display: inline-block;
    font-size: 16px;
    margin: 4px 10px;
    cursor: pointer;
    margin-bottom: 100px;
}

</style>
